class FeatureExtractor(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  sub_levels : int
  extract_sublevels : __torch__.feature_extractor.SubTreeExtractor
  def forward(self: __torch__.feature_extractor.FeatureExtractor,
    image_pyramid: List[Tensor]) -> List[Tensor]:
    sub_pyramids = annotate(List[List[Tensor]], [])
    for i in range(torch.len(image_pyramid)):
      _0 = torch.sub(torch.len(image_pyramid), i)
      sub_levels = self.sub_levels
      capped_sub_levels = ops.prim.min(_0, sub_levels)
      extract_sublevels = self.extract_sublevels
      _1 = (extract_sublevels).forward(image_pyramid[i], capped_sub_levels, )
      _2 = torch.append(sub_pyramids, _1)
    feature_pyramid = annotate(List[Tensor], [])
    for i0 in range(torch.len(image_pyramid)):
      features = (sub_pyramids[i0])[0]
      sub_levels0 = self.sub_levels
      _3 = torch.__range_length(1, sub_levels0, 1)
      features0 = features
      for _4 in range(_3):
        j = torch.__derive_index(_4, 1, 1)
        if torch.le(j, i0):
          _5 = sub_pyramids[torch.sub(i0, j)]
          features2 = torch.cat([features0, _5[j]], 1)
          features1 = features2
        else:
          features1 = features0
        features0 = features1
      _6 = torch.append(feature_pyramid, features0)
    return feature_pyramid
class SubTreeExtractor(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  convs : __torch__.torch.nn.modules.container.ModuleList
  def forward(self: __torch__.feature_extractor.SubTreeExtractor,
    image: Tensor,
    n: int) -> List[Tensor]:
    _7 = annotate(List[Tensor], [])
    convs = self.convs
    _0 = getattr(convs, "0")
    _1 = getattr(convs, "1")
    _2 = getattr(convs, "2")
    _3 = getattr(convs, "3")
    head = (_0).forward(image, )
    _8 = torch.append(_7, head)
    if torch.lt(0, torch.sub(n, 1)):
      head1 = torch.avg_pool2d(head, [2, 2], [2, 2])
      head0 = head1
    else:
      head0 = head
    head2 = (_1).forward(head0, )
    _9 = torch.append(_7, head2)
    if torch.lt(1, torch.sub(n, 1)):
      head4 = torch.avg_pool2d(head2, [2, 2], [2, 2])
      head3 = head4
    else:
      head3 = head2
    head5 = (_2).forward(head3, )
    _10 = torch.append(_7, head5)
    if torch.lt(2, torch.sub(n, 1)):
      head7 = torch.avg_pool2d(head5, [2, 2], [2, 2])
      head6 = head7
    else:
      head6 = head5
    head8 = (_3).forward(head6, )
    _11 = torch.append(_7, head8)
    return _7
