class PyramidFlowEstimator(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  _predictor : __torch__.pyramid_flow_estimator.FlowEstimator
  _predictors : __torch__.torch.nn.modules.container.___torch_mangle_50.ModuleList
  def forward(self: __torch__.pyramid_flow_estimator.PyramidFlowEstimator,
    feature_pyramid_a: List[Tensor],
    feature_pyramid_b: List[Tensor]) -> List[Tensor]:
    _0 = __torch__.torch.nn.functional.___torch_mangle_73.interpolate
    levels = torch.len(feature_pyramid_a)
    _predictor = self._predictor
    v = (_predictor).forward(feature_pyramid_a[-1], feature_pyramid_b[-1], )
    residuals = [v]
    _1 = torch.sub(levels, 2)
    _predictors = self._predictors
    _2 = torch.sub((_predictors).__len__(), 1)
    v0 = v
    for _3 in range(torch.__range_length(_1, _2, -1)):
      i = torch.__derive_index(_3, _1, -1)
      level_size = torch.slice(torch.size(feature_pyramid_a[i]), 2, 4)
      v1 = _0(torch.mul(v0, 2), level_size, None, "bilinear", None, None, False, )
      warped = __torch__.util.warp(feature_pyramid_b[i], v1, )
      _predictor0 = self._predictor
      v_residual = (_predictor0).forward(feature_pyramid_a[i], warped, )
      torch.insert(residuals, 0, v_residual)
      v0 = torch.add(v_residual, v1)
    _predictors0 = self._predictors
    _00 = getattr(_predictors0, "0")
    _10 = getattr(_predictors0, "1")
    _20 = getattr(_predictors0, "2")
    _predictors1 = self._predictors
    _4 = torch.sub((_predictors1).__len__(), 1)
    i0 = torch.sub(_4, 0)
    level_size0 = torch.slice(torch.size(feature_pyramid_a[i0]), 2, 4)
    v2 = _0(torch.mul(v0, 2), level_size0, None, "bilinear", None, None, False, )
    warped0 = __torch__.util.warp(feature_pyramid_b[i0], v2, )
    v_residual0 = (_00).forward(feature_pyramid_a[i0], warped0, )
    torch.insert(residuals, 0, v_residual0)
    v3 = torch.add(v_residual0, v2)
    _predictors2 = self._predictors
    _5 = torch.sub((_predictors2).__len__(), 1)
    i1 = torch.sub(_5, 1)
    level_size1 = torch.slice(torch.size(feature_pyramid_a[i1]), 2, 4)
    v4 = _0(torch.mul(v3, 2), level_size1, None, "bilinear", None, None, False, )
    warped1 = __torch__.util.warp(feature_pyramid_b[i1], v4, )
    v_residual1 = (_10).forward(feature_pyramid_a[i1], warped1, )
    torch.insert(residuals, 0, v_residual1)
    v5 = torch.add(v_residual1, v4)
    _predictors3 = self._predictors
    _6 = torch.sub((_predictors3).__len__(), 1)
    i2 = torch.sub(_6, 2)
    level_size2 = torch.slice(torch.size(feature_pyramid_a[i2]), 2, 4)
    v6 = _0(torch.mul(v5, 2), level_size2, None, "bilinear", None, None, False, )
    warped2 = __torch__.util.warp(feature_pyramid_b[i2], v6, )
    v_residual2 = (_20).forward(feature_pyramid_a[i2], warped2, )
    torch.insert(residuals, 0, v_residual2)
    return residuals
class FlowEstimator(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  _convs : __torch__.torch.nn.modules.container.___torch_mangle_23.ModuleList
  def forward(self: __torch__.pyramid_flow_estimator.FlowEstimator,
    features_a: Tensor,
    features_b: Tensor) -> Tensor:
    net = torch.cat([features_a, features_b], 1)
    _convs = self._convs
    _0 = getattr(_convs, "0")
    _1 = getattr(_convs, "1")
    _2 = getattr(_convs, "2")
    _3 = getattr(_convs, "3")
    _4 = getattr(_convs, "4")
    net0 = (_0).forward(net, )
    net1 = (_1).forward(net0, )
    net2 = (_2).forward(net1, )
    net3 = (_3).forward(net2, )
    return (_4).forward(net3, )
