def leaky_relu(input: Tensor,
    negative_slope: float=0.01,
    inplace: bool=False) -> Tensor:
  if inplace:
    result0 = torch.leaky_relu_(input, negative_slope)
    result = result0
  else:
    result1 = torch.leaky_relu(input, negative_slope)
    result = result1
  return result
def adaptive_avg_pool2d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _0 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _0:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _1 = torch.adaptive_avg_pool2d(input, output_size)
  return _1
def adaptive_avg_pool3d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _2 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _2:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _3 = torch.adaptive_avg_pool3d(input, output_size)
  return _3
def grid_sample(input: Tensor,
    grid: Tensor,
    mode: str="bilinear",
    padding_mode: str="zeros",
    align_corners: Optional[bool]=None) -> Tensor:
  _4 = "nn.functional.grid_sample(): expected mode to be \'bilinear\', \'nearest\' or \'bicubic\', but got: \'{}\'"
  _5 = "nn.functional.grid_sample(): expected padding_mode to be \'zeros\', \'border\', or \'reflection\', but got: \'{}\'"
  _6 = "Default grid_sample and affine_grid behavior has changed to align_corners=False since 1.3.0. Please specify align_corners=True if the old behavior is desired. See the documentation of grid_sample for details."
  if torch.ne(mode, "bilinear"):
    _7 = torch.ne(mode, "nearest")
  else:
    _7 = False
  if _7:
    _8 = torch.ne(mode, "bicubic")
  else:
    _8 = False
  if _8:
    ops.prim.RaiseException(torch.format(_4, mode), "builtins.ValueError")
  else:
    pass
  if torch.ne(padding_mode, "zeros"):
    _9 = torch.ne(padding_mode, "border")
  else:
    _9 = False
  if _9:
    _11 = torch.ne(padding_mode, "reflection")
    _10 = _11
  else:
    _10 = False
  if _10:
    ops.prim.RaiseException(torch.format(_5, padding_mode), "builtins.ValueError")
  else:
    pass
  if torch.eq(mode, "bilinear"):
    mode_enum = 0
  else:
    if torch.eq(mode, "nearest"):
      mode_enum0 = 1
    else:
      mode_enum0 = 2
    mode_enum = mode_enum0
  if torch.eq(padding_mode, "zeros"):
    padding_mode_enum = 0
  else:
    if torch.eq(padding_mode, "border"):
      padding_mode_enum0 = 1
    else:
      padding_mode_enum0 = 2
    padding_mode_enum = padding_mode_enum0
  if torch.__is__(align_corners, None):
    torch.warn(_6)
    align_corners0 = False
  else:
    align_corners0 = unchecked_cast(bool, align_corners)
  _12 = torch.grid_sampler(input, grid, mode_enum, padding_mode_enum, align_corners0)
  return _12
