class Conv2d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  size : int
  __annotations__["0"] = __torch__.torch.nn.modules.conv.Conv2d
  activation : __torch__.torch.nn.modules.activation.LeakyReLU
  def forward(self: __torch__.util.Conv2d,
    x: Tensor) -> Tensor:
    size = self.size
    _0 = torch.__not__(bool(torch.remainder(size, 2)))
    if _0:
      x0 = torch.pad(x, [0, 1, 0, 1])
    else:
      x0 = x
    _00 = getattr(self, "0")
    y = (_00).forward(x0, )
    activation = self.activation
    return (activation).forward(y, )
  def __len__(self: __torch__.util.Conv2d) -> int:
    return 2
def flow_pyramid_synthesis(residual_pyramid: List[Tensor]) -> List[Tensor]:
  _1 = __torch__.torch.nn.functional.___torch_mangle_73.interpolate
  flow = residual_pyramid[-1]
  flow_pyramid = [flow]
  _2 = torch.slice(residual_pyramid, None, -1)
  _3 = torch.slice(_2, None, None, -1)
  flow0 = flow
  for _4 in range(torch.len(_3)):
    residual_flow = _3[_4]
    level_size = torch.slice(torch.size(residual_flow), 2, 4)
    flow1 = _1(torch.mul(flow0, 2), level_size, None, "bilinear", None, None, False, )
    flow2 = torch.add(residual_flow, flow1)
    torch.insert(flow_pyramid, 0, flow2)
    flow0 = flow2
  return flow_pyramid
def multiply_pyramid(pyramid: List[Tensor],
    scalar: Tensor) -> List[Tensor]:
  _5 = annotate(List[Tensor], [])
  for _6 in range(torch.len(pyramid)):
    image = pyramid[_6]
    _7 = torch.unsqueeze(torch.unsqueeze(scalar, -1), -1)
    _8 = torch.append(_5, torch.mul(image, _7))
  return _5
def concatenate_pyramids(pyramid1: List[Tensor],
    pyramid2: List[Tensor]) -> List[Tensor]:
  _9 = annotate(List[Tensor], [])
  _10 = [torch.len(pyramid1), torch.len(pyramid2)]
  for _11 in range(ops.prim.min(_10)):
    features1 = pyramid1[_11]
    features2 = pyramid2[_11]
    _12 = torch.cat([features1, features2], 1)
    _13 = torch.append(_9, _12)
  return _9
def pyramid_warp(feature_pyramid: List[Tensor],
    flow_pyramid: List[Tensor]) -> List[Tensor]:
  _14 = annotate(List[Tensor], [])
  _15 = [torch.len(feature_pyramid), torch.len(flow_pyramid)]
  for _16 in range(ops.prim.min(_15)):
    features = feature_pyramid[_16]
    flow = flow_pyramid[_16]
    _17 = __torch__.util.warp(features, flow, )
    _18 = torch.append(_14, _17)
  return _14
def build_image_pyramid(image: Tensor,
    pyramid_levels: int=3) -> List[Tensor]:
  _19 = annotate(List[Tensor], [])
  image0 = image
  for i in range(pyramid_levels):
    _20 = torch.append(_19, image0)
    _21 = torch.lt(i, torch.sub(pyramid_levels, 1))
    if _21:
      image2 = torch.avg_pool2d(image0, [2, 2], [2, 2])
      image1 = image2
    else:
      image1 = image0
    image0 = image1
  return _19
def warp(image: Tensor,
    flow: Tensor) -> Tensor:
  _22 = __torch__.torch.nn.functional.grid_sample
  flow3 = torch.neg(torch.flip(flow, [1]))
  dtype = ops.prim.dtype(flow3)
  device = ops.prim.device(flow3)
  ls1 = torch.sub(1, torch.div(1, (torch.size(flow3))[3]))
  ls2 = torch.sub(1, torch.div(1, (torch.size(flow3))[2]))
  _23 = torch.permute(flow3, [0, 2, 3, 1])
  _24 = torch.mul((torch.size(flow3))[2], 0.5)
  _25 = torch.mul((torch.size(flow3))[3], 0.5)
  _26 = torch.tensor([_24, _25], dtype=dtype, device=device)
  _27 = torch.unsqueeze(torch.unsqueeze(_26, 0), 1)
  normalized_flow2 = torch.div(_23, torch.unsqueeze(_27, 2))
  _28 = torch.linspace(torch.neg(ls1), ls1, (torch.size(flow3))[3], dtype=dtype, layout=None, device=device)
  _29 = torch.unsqueeze(torch.unsqueeze(_28, 0), 1)
  _30 = torch.sub(torch.slice(_29, 2), torch.select(normalized_flow2, -1, 1))
  _31 = torch.linspace(torch.neg(ls2), ls2, (torch.size(flow3))[2], dtype=dtype, layout=None, device=device)
  _32 = torch.slice(torch.unsqueeze(_31, 0), 1)
  _33 = torch.sub(torch.unsqueeze(_32, 2), torch.select(normalized_flow2, -1, 0))
  normalized_flow20 = torch.stack([_30, _33], 3)
  warped = _22(image, normalized_flow20, "bilinear", "border", False, )
  _34 = torch.reshape(warped, torch.size(image))
  return _34
